--- //.git/fs/object/2f8a59f4b5bfe028c022855acc19666d69eed909/tree//sys/man/2/mouse
+++ /sys/man/2/mouse
@@ -29,6 +29,12 @@
 void		moveto(Mousectl *mc, Point pt)
 .PP
 .B
+int		clipmouse(Mousectl *mc, Rectangle r)
+.PP
+.B
+void		unclipmouse(Mousectl *mc)
+.PP
+.B
 void		setcursor(Mousectl *mc, Cursor *c)
 .PP
 .B
@@ -96,6 +102,7 @@
 
 	char	*file;
 	int	mfd;		/* to mouse file */
+	int	mctlfd;		/* to mousectl file */
 	int	cfd;		/* to cursor file */
 	int	pid;		/* of slave proc */
 	Image*	image;	/* of associated window/display */
@@ -164,6 +171,12 @@
 .I Moveto
 moves the mouse cursor on the display to the position specified by
 .IR pt .
+.PP
+.I Clipmouse
+restricts the mouse movement to the area inside
+.IR r .
+.I Unclipmouse
+frees the mouse of any previous clip operation.
 .PP
 .I Setcursor
 sets the image of the cursor to that specified by
--- //.git/fs/object/2f8a59f4b5bfe028c022855acc19666d69eed909/tree//sys/man/3/mouse
+++ /sys/man/3/mouse
@@ -171,6 +171,15 @@
 .B twitch
 unblanks the screen and resets the idle timeout as if the
 mouse was twitched.
+.TP
+.BI clip " x0" " y0" " x1" " y1"
+restricts the mouse movement to the area inside the provided rectangle.
+The provided rectangle must be fully contained inside the screen.
+.TP
+.BI unclip
+undoes any previous
+.I clip
+operations, letting the mouse move freely across the screen.
 .PD
 .PP
 Not all mice interpret all messages; with some devices,
@@ -203,6 +212,13 @@
 file sets the current cursor information.
 A write of fewer than 72 bytes sets the
 cursor to the default, an arrow.
+.PP
+A
+.I clip
+is valid as long as the file that requested it is kept open.
+When it's closed, the clip is forcibly released.
+This is a security mechanism against crashing apps,
+which would otherwise leave an unwanted active grab.
 .PP
 The
 .B mouse
